import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:gap/gap.dart';
import 'package:tanami_app/shared/components/loader.dart';
import 'package:tanami_app/shared/components/toast_message.dart';

import '../../../../core/routes/route_name.dart';
import '../../../../core/routes/routes.dart';
import '../../../../core/styles/app_color.dart';
import '../../../../core/styles/app_text.dart';
import '../../../../shared/components/button_widget.dart';
import '../../../../shared/components/text_widget.dart';
import '../../../countrySelection/presentation/bloc/choose_country_bloc.dart';
import '../bloc/restore_password_bloc.dart';
import '../bloc/restore_password_event.dart';
import '../bloc/restore_password_state.dart';

class RestorePasswordBottomSection extends StatelessWidget {
  const RestorePasswordBottomSection({
    super.key,
  });

  @override
  Widget build(BuildContext context) {
    final radioBloc = context.read<RadioBloc>();
    return Column(
      children: [
        BlocConsumer<RestorePasswordBloc, RestorePasswordState>(
          listener: (context, state) {
            if (state is RestorePasswordLoading) {
              Loader.loader(context);
            } else if (state is RestorePasswordSuccess) {
              successToastMessage(context, "Password resetted successful !");
              goRouter.pop();
              radioBloc.resetSelection();
              goRouter.goNamed(RouteName.loginScreen, pathParameters: {
                "fromScreen": "registerStep",
              });
            } else if (state is RestorePasswordFailure) {
              goRouter.pop();
              errorToastMessage(
                context,
                state.error,
              );
            }
          },
          builder: (context, state) {
            bool isButtonEnabled = false;
            if (state is RestorePasswordFieldsState) {
              isButtonEnabled = state.areFieldsFilled;
            } else if (state is RestorePasswordSuccess ||
                state is RestorePasswordFailure) {
              isButtonEnabled = true;
            }
            return Container(
              margin: const EdgeInsets.symmetric(
                horizontal: 16,
              ),
              width: 1.sw,
              height: 56.h,
              child: ButtonWidget().elevatedBtn(
                txtClr: isButtonEnabled
                    ? AppColor.plainWhite
                    : AppColor.inactiveBtnTxtColor,
                function: () {
                  isButtonEnabled
                      ? context.read<RestorePasswordBloc>().add(
                            RestorePasswordSubmitted(
                                context
                                    .read<RestorePasswordBloc>()
                                    .passwordTextField
                                    .text,
                                ""),
                          )
                      : null;
                },
                text: AppText.submitText,
                clr: isButtonEnabled
                    ? AppColor.primaryColor2
                    : AppColor.inactiveBtnColor,
              ),
            );
          },
        ),
        const Gap(5),
        ButtonWidget().textBtn(
            function: () {
              goRouter.pop();
            },
            text: TextWidget().text14W700(AppText.backText,
                clr: AppColor.textLabelColor,
                textDecoration: TextDecoration.underline)),
      ],
    );
  }
}
